add devbyid dependency
[automated-distro-installer] / pxe-server
index 3223fb9033d4f461706cccd0e3e06a6d2480bba2..9c3f917fcaceee7a488453759aa6eed44b528250 100755 (executable)
@@ -28,18 +28,20 @@ trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 usage() {
     cat <<EOF
-Usage: ${0##*/} [OPTIONS] TYPE [HOST]
+Usage: ${0##*/} [OPTIONS] [HOST TYPE]
 One line description
 
-TYPE is one of arch, plain, fai, or : for no pxe server.
-HOST makes the pxe server only for that specific host
+TYPE is one of arch, plain, fai.
+HOST is a hostname known to the dhcp server, or default for all, or none to disable
 
--r         Don't redeploy fai config.
+-r         Don't redeploy fai config. For example, if there is a different host
+           that is mid-install.
 -a         Wait for 2 dhcp acks, then disable the pxe server after a delay.
            First ack is for pxe boot, 2nd ack is for os boot. Sometimes
            on debian, there is a 3rd one shortly after the 2nd. I can't remember
            exactly why this caused a problem, but I'm hoping the sleep
            will take care of it.
+-w         Initially setup pxe, then wait like -a.
 -h|--help  Print help and exit
 
 
@@ -54,24 +56,29 @@ args=()
 redep=true
 acks=2
 wait=false
-temp=$(getopt -l help hra "$@") || usage 1
+temp=$(getopt -l help harw "$@") || usage 1
 eval set -- "$temp"
 while true; do
     case $1 in
-        -h|--help) usage ;;
+        -a) wait=true; set=false; shift ;;
         -r) redep=false; shift ;;
-        -a) wait=true; shift ;;
+        -w) wait=true; set=true; shift ;;
+        -h|--help) usage ;;
         --) shift; break ;;
         *) echo "$0: Internal error!" ; exit 1 ;;
     esac
 done
 
-read type host <<<"$@"
+read host type <<<"$@"
 
-if [[ ! $type ]]; then
-    echo "$0: error: exptected 1 argument of type"
-    usage 1
-fi
+case $# in
+    0|2);;
+    *)
+        echo "$0: error: expected 0 or 2 arguments"
+        echo
+        usage 1
+        ;;
+esac
 
 if [[ $host ]]; then
     host_tag="tag:$host,"
@@ -103,7 +110,7 @@ EOF
 fai() {
     cat <<EOF
 $set_host_tag
-dhcp-boot=${host_tag}fai/pxelinux.0,faiserver.lan,faiserver.lan
+dhcp-boot=${host_tag}pxelinux.0,faiserver.lan,faiserver.lan
 EOF
 }
 
@@ -125,17 +132,21 @@ ack-wait() {
 }
 
 set-pxe() {
-    ${1:-$type} | ssh wrt "cedit pxe-server /etc/dnsmasq.conf || /etc/init.d/dnsmasq restart
-if [[ $type == arch ]]; then arch-pxe-mount; fi"
+    ${type:-:}|ssh wrt "cedit pxe /etc/dnsmasq.conf || /etc/init.d/dnsmasq restart
+$([[ $type == arch ]] && echo arch-pxe-mount)"
 }
 
-set-pxe
 
-if [[ $type == fai ]]; then
-    if $redep; then
-        fai-redep
+if $set; then
+    set-pxe
+    if [[ $type == fai ]]; then
+        e myfai-chboot $host
+        if $redep; then
+            e fai-redep
+        fi
+    else
+        e myfai-chboot
     fi
-    faiserver-enable
 fi
 
 if $wait; then
@@ -145,7 +156,8 @@ if $wait; then
     # bleh.
     echo "waiting for $acks dhcp acks then disabling pxe"
     ack-wait $acks
-    set-pxe :
+    type=
+    set-pxe
 
     # previously tried waiting for one more ack then disabling faiserver,
     # since it can contain sensitive info, so turn it off when not in use,